#!/usr/bin/perl -w

############################################################
#
#  Justino Martinez, 1998-2002   biblioteca@webviva.com
#                           http://www.webviva.com/biblioteca
#
#  TotMail.cgi V3.2
#
############################################################
#
# Historia
#
# Version 3.2 - 2002
#			- Aadida la opcion de incluir la prioridad del 
#			E-mail en el mismo formulario 
# Version 3.1 - 2002
#			- Aadida la opcion de proteger el CGI para que no 
#			pueda ser usado por formularios no autorizados
#
# Version 3.0d - 2002
#			- Corregido un fallo "estetico" al tener un error de 
#			conexion STMP (gracias a Edgar Hernandez por avisarme
#			de que no se redirigia correctamente a la pagina de error)
#			- Se ha evitado el uso de la cabecera Location ya que no
#			sigue el estandar.
# Version 3.0c - 2002
#			- Corregido un pequeo bug en el From: si no se incluia el
#			campo Totmailreply no aparecia el From de forma correcta
# Version 3.0b - 2001
#			- Corregidos pequeos detalles en el envio de selecciones 
#			mltiples
# Version 3.0a - 2001
#			- Corregidos pequeos detalles en la rutina de toma de ficheros
#			anexados
# Version 3.0 - 2000
#			- Validez para sistemas NT y UNIX/Linux (Gracias a 
#			Ana La mistica18@hotmail.com por pasarme 
#			la rutina de envio de correos a traves de 
#			un servidor smtp)
#
#			- Posibilidad de enviar ficheros de cualquier
#			tipo anexados al e-mail (en teoria puede incluir un 
#			numero ilimitado de campos del tipo "file"). Permite 
#			acotar el tamao (en Kbytes) de los ficheros enviados
#
#			- Optimizacion de los datos externos enviados
#			al CGI (direccion de correo, campos obligatorios)
#
#			- Posibilidad de recibir los campos en un orden
#			preestablecido distinto al orden del formulario
#
#			- Si uno de los campos corresponde a la direccion
#			de correo de la persona que rellena el formulario
#			se incluye esta direccion como "reply" del mail 
#			recibido. 
#
#			- Si uno de los campos es el mail de la persona que 
#			rellena el formulario puede hacerse que sta reciba una
#			copia de sus contestaciones al formulario.
#			
# Version 2.0 - Version para ser usada en un servidor remoto
#
# Version 1.1 - 2000 
#			- Recepcion de los campos en el orden en que
#			se hallan en el formulario
#                 - Respuesta al visitante usando un documento HTML
#			externo
#
# Version 1.0 - 1998
#
############################################################
#
#  Envia por correo el contenido de un formulario. Permite 
#  formularios de todo tipo (incluso con campos del tipo "file")
# 
############################################################
#
# TotMail puede copiarse, modificarse y usarse 
# libremente a condicion de que no se borre ni modifique 
# la cabecera ni este texto.
#
############################################################
#
# Llamada desde el formulario:
#
# 1.- Si no hay campos del tipo "file"
#    <form method=POST action="URL de este cgi">
# 2.- Si hay campos del tipo "file"
#    <form method=POST enctype="multipart/form-data" action="URL de este cgi">
#
# Como pasar los parametros al CGI. Los parametros como, los 
# campos que son obligatorios, el orden de los campos en el mail, etc
# se pasan con campos ocultos en el formulario:
#
#  Mail de destino
#	<input type="hidden" name="Totmaildestino" value="direccion1,direccion2...">
#
#  Orden de los campos. Si se impone un orden hay que definir el orden de TODOS los campos
#  (excepto el de los que empiezan por Totmail ya que estos son de uso interno del CGI)
#	<input type="hidden" name="Totmailorden" value="campo1,campo2,campo3....">
#
#  Campos obligatorios
#	<input type="hidden" name="Totmailobligatorios" value="campo2,campo5....">
#
#  Asunto (subject) con el que se recibira el mail
#	<input type="hidden" name="Totmailasunto" value="Frase">
#
#  Si se desea que la persona que rellena el formulario reciba una copia del 
#  mail puede incluirse el siguiente campo
#	<input type="hidden" name="Totmailreply" value="Nombre del campo del formulario 
#									que contendra el mail del visitante
#									que rellena el formulario">
#
#  Acotar el tamao de cada uno de los ficheros enviados (este ejemplo
#  no permitiria que se enviaran fichero de mas de 50Kb). Si no se desea
#  acotar el tamao no ponga este campo en el formulario.
#
#	<input type="hidden" name="Totmailmaxsize" value="50">
#
#  URL de la pagina de destino si se tiene exito en el envio
#	<input type="hidden" name="Totmailurlfinal" value="URL de la pagina destino">
#
#  URL de la pagina que se muestra si alguno de los campos obligatorios
#  no fue completado
#	<input type="hidden" name="Totmailurlfalta" value="URL de la pagina de advertencia">
#
#  URL de la pagina que se muestra si hay algun error durante el envio del mail
#	<input type="hidden" name="Totmailurlerror" value="URL de la pagina de error">
#
#  URL de la pagina que se muestra si el mail dado en el campo "Totmailemail" no es 
#  sintacticamente correcto (i.e si no es de la forma Y@Z.T)
#	<input type="hidden" name="Totmailurlmailanomalo" value="URL de la pagina a mostrar">
#
#  URL de la pagina que se muestra si alguno de los ficheros anexados supera
#  el tamao preestablecido. Si no puso el campo oculto "Totmailmaxsize", este
#  campo no es necesario
#
#    <input type="hidden" name="Totmailurlmax" value="URL de la pagina">
#
#	
#  Si uno de los campos corresponde al E-Mail de la persona que rellena
#  el formulario puede hacerse que el mail recibido pueda ser contestado
#  a dicha persona con solo hacer "reply" si se nombra a ese campo como
#  Totmailemail. Es decir el campo podria ser asi
#	Su E-Mail: <input type="text" name="Totmailemail">
#
#  Prioridad del mensaje. Puede establecerse como un campo oculto o bien 
#  como una lista seleccionable y que sea el usurio que cumplimenta el 
#  formulario el que decida la prioridad. Si no se incluye este campo 
#  la prioridad es normal.
#
#  <input type="hidden" name="Totmailprioridad" value="1">
#
#  Los posibles valores son 1=Muy alta,2=Alta,3=Normal,4=Baja,5=Muy baja
#
#  Este campo no es esencial
#
############################################################
# Advertencias:
# 
#	1.- Estos campos especiales tienen por nombre Totmailxxxx,
#     es decir con la inicial de Totmail en mayusculas y el resto en minusculas
#
#	2.- Ningun campo (aparte de los especiales) puede tener un nombre que 
#	empiece por Totmail
#
############################################################
#
# Instalacion: 
#           Definir las variables de abajo.
#
#		En sistemas NT dar extension pl a este cgi 
#		y pasarlo al servidor por FTP en modo ASCII
#
#		En sistemas UNIX/Linux, dar el path del interprete perl 
#		en la linea superior (la que empieza por #!) y dar
#           permisos 755 a este script.
#		Si no sabe como dar permisos 755 consulte la seccion
#		"Informacion"->"Ayudas" de http://www.webviva.com/biblioteca
#		Si no sabe cual es el path del interprete perl en su 
#		servidor consulte al administrador de su servidor Web
#
############################################################

##########################
# Definimos las variables

# Que sistema usa su servidor Web?
# [0=NT,1=UNIX/Linux]

$sistema_web=1;

# Si desea impedir que formularios no autorizados usen este
# cgi, aada la/s url/s que pueden usar este CGI.
# Por ejemplo @autorizadas=("www.miweb.com","www.lademisamigos.com/pepe");
# permite que cualquier formulario situado en esos servidores usen este CGI
# Si no desea impedir el uso a nadie entonces ponga 
# @autorizadas=("");

@autorizadas=("");

#######################
# Si su sistema es NT 
#######################

# Debe dar el nombre de un servidor SMTP valido 
# (pregunte al administrador de su espacio Web 
# que servidor SMTP puede usar)

$SMTP_server="smtp.wanadoo.es";

##############################
# Si su sistema es UNIX/Linux
##############################

# Donde esta el sendmail? 
# Si no sabe el path de sendmail en su sistema, pregunte
# al administrador de su espacio Web.
# En el caso de UNIX o Linux tiene libertad para usar
# sendmail o bien para usar un servidor de SMTP. Si 
# desea usar un servidor de SMTP, defina la variable 
# $SMTP_server de mas arriba y deje la variable
# $mailprog vacia (es decir como $mailprog='';)
#
# Aadir la opcion -t al final del path!

$mailprog = '/usr/sbin/sendmail -t';


####################################################################
# A partir de aqui no hay que tocar nada
####################################################################

# Si vamos a realizar el envio por SMTP

if (($sistema_web == 0)||($mailprog eq "")){
	use Socket;
	$fix_mail = "No";  # En ocasiones es posible que tenga que cambiarse a Si
	$tipo_mail="smtp";	   
} else {
	$tipo_mail="sendmail";
}

# Toma las entradas del formulario

$total_entradas=&toma_entradas;

$version="3.2";

# Tomamos el valor de los campos ocultos

$campo_destino = $parame{'Totmaildestino'};
$campo_orden= $parame{'Totmailorden'};
$campo_obligatorios = $parame{'Totmailobligatorios'};
$campo_asunto=$parame{'Totmailasunto'};
$campo_tamanio=$parame{'Totmailmaxsize'};
$campo_urlfinal=$parame{'Totmailurlfinal'};
$campo_urlincompleto=$parame{'Totmailurlfalta'};
$campo_urlerror=$parame{'Totmailurlerror'};
$campo_urlnopermiso=$parame{'Totmailnopermiso'};
$campo_urlmax=$parame{'Totmailurlmax'};
$campo_urlmailanomalo=$parame{'Totmailurlmailanomalo'};
$campo_reply=$parame{'Totmailreply'};
$campo_remite=$parame{'Totmailemail'};
$campo_prioridad=$parame{'Totmailprioridad'};

# Veamos si el formulario esta autorizado a usar este CGI

$_="$ENV{HTTP_REFERER}";
$valido=0;
foreach $tmp (@autorizadas){
        if (/$tmp/){$valido=1;}
}
if ($valido < 1){
   	&responde($campo_urlnopermiso);
	exit;
}

# Damos un repaso a los campos ocultos para ver si el
# formulario est bien construido

$titulo="Formulario mal construido";


if (not defined $campo_destino){
	$mensaje="<P>Falta el/los destinatario/s del E-Mail</P>";
	$mensaje.="<P>Recuerde que debe incluir un campo oculto como este</P>";
	$mensaje.="&lt;input type=\"hidden\" name=\"Totmaildestino\" value=\"direccion1,direccion2...\"&gt;";
	&error($titulo,$mensaje);
	exit;
}

@destinatarios=split(/\,/,$campo_destino);

@orden=();
if (defined $campo_orden){
	@orden=split(/\,/,$campo_orden);
}

@obligatorios=();
@obligatorios=split(/\,/,$campo_obligatorios) unless (not defined $campo_obligatorios);

$campo_asunto="Sin titulo" unless (defined $campo_asunto);

if (not defined $campo_urlfinal){
	$mensaje="<P>No ha indicado la url que debe mostrarse tras el env&iacute;o del formulario</P>";
	$mensaje.="<P>Recuerde que debe incluir un campo oculto como este</P>";
	$mensaje.="&lt;input type=\"hidden\" name=\"Totmailurlfinal\" value=\"URL a mostrar\"&gt;";
	&error($titulo,$mensaje);
	exit;
}

if ((defined $campo_obligatorios)&&(not defined $campo_urlincompleto)){
	$mensaje="<P>No ha indicado la url que debe mostrarse si el formulario no es completado adecuadamente</P>";
	$mensaje.="<P>Recuerde que debe incluir un campo oculto como este</P>";
	$mensaje.="&lt;input type=\"hidden\" name=\"Totmailurlfalta\" value=\"URL a mostrar\"&gt;";
	&error($titulo,$mensaje);
	exit;
}

if (not defined $campo_urlerror){
	$mensaje="<P>No ha indicado la url que debe mostrarse si sucede un error durante el env&iacute;o del correo</P>";
	$mensaje.="<P>Recuerde que debe incluir un campo oculto como este</P>";
	$mensaje.="&lt;input type=\"hidden\" name=\"Totmailurlerror\" value=\"URL a mostrar\"&gt;";
	&error($titulo,$mensaje);
	exit;
}

if ((defined $campo_tamanio)&&(not defined $campo_urlmax)){
	$mensaje="<P>No ha indicado la url que debe mostrarse si uno de los ficheros anexados supera los $campo_tamanio Kbytes</P>";
	$mensaje.="<P>Recuerde que debe incluir un campo oculto como este</P>";
	$mensaje.="&lt;input type=\"hidden\" name=\"Totmailurlmax\" value=\"URL a mostrar\"&gt;";
	&error($titulo,$mensaje);
	exit;
}

if ((defined $campo_remite)&&(not defined $campo_urlmailanomalo)){
	$mensaje="<P>No ha indicado la url que debe mostrarse si el mail del visitante no es sintacticamente correcto.</P>";
	$mensaje.="<P>Recuerde que debe incluir un campo oculto como este</P>";
	$mensaje.="&lt;input type=\"hidden\" name=\"Totmailurlmailanomalo\" value=\"URL a mostrar\"&gt;";
	&error($titulo,$mensaje);
	exit;
}

if (defined $campo_tamanio){$campo_tamanio=$campo_tamanio*1024;}


#---------
#--------- Preparamos los ficheros anexados
#---------

while (($nombre_campo,$valor_campo)=each(%nombre_fichero)){
	if ((defined $campo_tamanio)&&(length($parame{$nombre_campo}) > $campo_tamanio)){
		&responde($campo_urlmax);
		exit;
	}
	$parame{$nombre_campo} = &b64encode($parame{$nombre_campo});
}

#------
#------ Comprobamos que se han rellenado los campos obligatorios
#------

$email_obligado=0;
if ($obligatorios[0] ne ""){
	foreach $tmp (@obligatorios){
		if ($tmp eq "Totmailemail"){$email_obligado=1;}
		$tmp2=$tmp;
		$tmp2=~s/^(\s)*//;
		$tmp2=~s/(\s)*$//;
		if ((!$parame{$tmp2})||($parame{$tmp2} eq "")){
			&responde($campo_urlincompleto);
			exit;
		}
	}
}

#------
#------ Comprobamos el mail del visitante es sintacticamente correcto
#------

if (($email_obligado==1)&&(defined $campo_remite)&&($campo_remite !~ /(.)+\@(.)+\.(.)+/)){
	&responde($campo_urlmailanomalo);
	exit;
}

#---------
#--------- Preparamos el envio 
#---------

#------- Generamos la cabecera del mail 

if ($sistema_web == 0){ 
	$newline="\r\n"; 
} else {
	$newline="\n";
}

@a_quien=@destinatarios;
if (defined $campo_remite){
	$de_quien=$campo_remite;
} else {
	$de_quien=$destinatarios[0];
}

$cabecera="";
if (defined $campo_reply){
	$cabecera .= "From: $parame{$campo_reply}$newline";
} else {
	if (defined $campo_remite){
		$cabecera .="From: $campo_remite$newline";
	}
}
$cabecera .= "To: $destinatarios[0]$newline";
shift @destinatarios;
foreach $tmp (@destinatarios){
	$tmp2=$tmp;
	$tmp2=~s/^(\s)*//;
	$tmp2=~s/(\s)*$//;
	$cabecera .= "Bcc: $tmp2$newline";
}
if ((defined $campo_reply)&&(defined $parame{$campo_reply})){
	$cabecera .= "Cc: $parame{$campo_reply}$newline";
}

$cabecera .= "Subject: $campo_asunto$newline";
if (defined $campo_remite){
	$cabecera .= "Reply-to: $campo_remite$newline";
}
if (defined $campo_prioridad) {
	$campo_prioridad=int($campo_prioridad*1);
	if ($campo_prioridad > 5) {$campo_prioridad=5;}
	if ($campo_prioridad < 1) {$campo_prioridad=1;}
	$cabecera .= "X-Priority: ".$campo_prioridad.$newline
}
$cabecera .= "X-Mailer: Totmail$version http://webviva.com  Creacion de paginas Web y CGIs$newline";
$pie="";
my @claves=keys(%nombre_fichero);
my $numero_files=$#claves+1;
if ($numero_files > 0){
	$boundary="------------WebViva";
	$cabecera .= "Content-Type: multipart/mixed; boundary=\"$boundary\"$newline";
	$cabecera .= "This is a multi-part message in MIME format.$newline";
	$cabecera .= "$newline--$boundary$newline";
	$cabecera .= "Content-Type: text/plain; charset=\"iso-8859-1\"$newline";
	$cabecera .= "Content-Transfer-Encoding: 8bit$newline$newline";

	$pie ="$newline";

	# Ponemos los attachments
	while (($nombre_campo,$valor_campo)=each(%nombre_fichero)){
		#------- Generamos la cabecera del attachment 
		$pie .= "--$boundary$newline";

		$pie .= "Content-Type: $tipo_fichero{$nombre_campo}; name=\"$valor_campo\"$newline";
		$pie .= "Content-Transfer-Encoding: base64$newline";
		$pie .= "Content-Description: $valor_campo$newline";
		$pie .= "Disposition: attachment; filename=\"$valor_campo\"$newline$newline";

		#------- Insertamos el fichero base64-codificada 

		$pie .= "$parame{$nombre_campo}$newline";
	}
	
	#------- Cerramos el mensaje 

	$pie .= "$boundary--$newline";
} else {
	$cabecera .= "Content-Type: text/plain; charset=\"iso-8859-1\"$newline";
	$cabecera .= "Content-Transfer-Encoding: 8bit$newline$newline";
}

#------- Generamos el cuerpo del mail 

#------
#------ Construimos el mail
#------

$mensaje_mail="";
if (not defined $campo_orden){
  	for ($i=0;$i<$total_entradas;$i++){
		$nombre_campo=$orden_entrada{$i};
		if (not defined $nombre_fichero{$nombre_campo}){
			$valor_campo=$parame{$nombre_campo};
			if ($valor_campo eq ""){$valor_campo="El visitante no ha respondido a este campo";}
		} else {
			$valor_campo="Ver fichero adjunto $nombre_fichero{$nombre_campo}";
		}
		if (($nombre_campo eq "Totmailemail")||($nombre_campo !~ /Totmail/)){
			$mensaje_mail.= "Contenido del campo $nombre_campo:$newline";  
			$mensaje_mail.= "$valor_campo$newline";
      		$mensaje_mail.= "-----------------------------------------------------------$newline";
		}
  	}	
} else {
	foreach $tmp (@orden){
		$tmp2=$tmp;
		$tmp2=~s/^(\s)*//;
		$tmp2=~s/(\s)*$//;
		$nombre_campo=$tmp2;
		if (not defined $nombre_fichero{$nombre_campo}){
			$valor_campo=$parame{$nombre_campo};
			if ($valor_campo eq ""){$valor_campo="El visitante no ha respondido a este campo";}
		} else {
			$valor_campo="Ver fichero adjunto $nombre_fichero{$nombre_campo}";
		}
		if (($nombre_campo eq "Totmailemail")||($nombre_campo !~ /Totmail/)){
			$mensaje_mail.= "Contenido del campo $nombre_campo:$newline";  
			$mensaje_mail.= "$valor_campo$newline";
      		$mensaje_mail.= "-----------------------------------------------------------$newline";
		}
	}
}

$mensaje_mail .= "Caractersticas de la mquina desde la que se ha enviado el correo:$newline";
$mensaje_mail .= "Direccin IP: $ENV{'REMOTE_ADDR'}$newline";
if (($ENV{'REMOTE_HOST'})&&($ENV{'REMOTE_HOST'} ne $ENV{'REMOTE_ADDR'})){
	$mensaje_mail .= "Nombre de la mquina: $ENV{'REMOTE_HOST'}$newline";
}
$mensaje_mail .= "Navegador empleado: $ENV{'HTTP_USER_AGENT'}$newline";
$mensaje_mail .= "-----------------------------------------------------------$newline";
$mensaje_mail .= "E-Mail enviado mediante Totmail$version$newline";
$mensaje_mail .= "Este CGI esta disponible en http://www.webviva.com$newline";
$mensaje_mail .= "-----------------------------------------------------------$newline";


$mensaje_mail ="$cabecera"."$mensaje_mail"."$pie";

if ($tipo_mail eq "smtp"){
	$prog=$SMTP_server;
} else {
	$prog=$mailprog;
}

$estado = &envia_mail($tipo_mail,$prog,$mensaje_mail,$de_quien,@a_quien);

if ($estado < 0){
	&responde($campo_urlerror);
	exit;
}

&responde($campo_urlfinal);

# ======================== SUBRUTINAS

# ---------------------------- Responde al usuario
sub responde  
{
	print "Content-type:text/html\n\n";
	print "<HTML><HEAD>\n<META http-equiv=REFRESH content=\"0;URL=$_[0]\">\n";
	print "</HEAD><BODY></BODY></HTML>";
}

###############################---------------------
# ---------------------------- Toma las entradas del formulario
###############################--------------------- 
###############################--------------------- 
sub toma_entradas {
	my ($total,@pares,@pares2,$nombre,$valor,$par,$buffer); 
	my ($tmp,@partes,$cabecera,$subcabecera,$boundary,$ctype,$fnombre); 
	my $tipo_form = $ENV{'CONTENT_TYPE'};
	my $reque = "$ENV{'REQUEST_METHOD'}";
	my %parame_tmp;
	$total=0;
	if ($reque eq 'GET') { 
	      @pares = split(/&/, $ENV{'QUERY_STRING'}); 
		foreach $par (@pares) { 
	      	($nombre, $valor) = split(/\=/, $par); 
			if (defined $parame_tmp{$nombre}) {
				$parame_tmp{$nombre}.="\n$valor";
			} else {
				$parame_tmp{$nombre}=$valor;
				$total++;
				$orden_entrada{$total}=$nombre;
			}
		}
		undef $nombre_fichero;
	} 
	if ($reque eq 'POST') { 
		if ($tipo_form =~ m#^multipart/form-data#){
			if ($sistema_web == 0){
				binmode(STDOUT);
				binmode(STDIN);
			}
    			($boundary) = $tipo_form =~ /boundary="([^"]+)"/; #";  
    			($boundary) = $tipo_form =~ /boundary=(\S+)/ unless $boundary;
			$boundary =  "--" . $boundary;
	      	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
			@partes=split(/$boundary/,$buffer);
			foreach $tmp (@partes){
				$cabecera="";
				$subcabecera="";
      			($cabecera,$valor) = split(/\r\n\r\n/, $tmp,2);
				if ($valor eq ""){
      				($cabecera,$valor) = split(/\n\n/, $tmp,2);
				}
				if ($valor=~/\r\n$/){
					$valor=~s/\r\n$//;
				} else {
					$valor=~s/\n$//;
				}

				$cabecera =~s/^\s*Content-Disposition://g;
				($cabecera,$subcabecera)=split(/\r\n/,$cabecera,2);

      			($nombre) = $cabecera =~ /\bname="([^"]+)"/i; #"; 
      			($nombre) = $cabecera =~ /\bname=([^\s:;]+)/i unless defined $nombre;  
      			($fnombre) = $cabecera =~ /\bfilename="([^"]*)"/i; #"; # filename puede ser nula
      			($fnombre) = $cabecera =~ /\bfilename=([^\s:;]+)/i unless defined $fnombre;
				if ($subcabecera ne ""){
			      	($ctype) = $subcabecera =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
		      		($ctype) = $subcabecera =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
				}
				if ((defined $fnombre)&&($fnombre ne "")){
					$nombre_fichero{$nombre}=$fnombre;
					$tipo_fichero{$nombre}=$ctype;
				}
				if (defined $nombre){
					if (defined $parame_tmp{$nombre}) {
						$parame_tmp{$nombre}.="\n$valor";
					} else {
						$parame_tmp{$nombre}=$valor;
						$orden_entrada{$total}=$nombre;
						$total++;
					}

				}
				undef $nombre;
				undef $fnombre;
				undef $ctype;
			}
		} else {
	      	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
	      	@pares = split(/&/, $buffer); 
			@pares2 = split(/&/, $ENV{'QUERY_STRING'});
			splice(@pares,$#pares+1,0,@pares2);
			foreach $par (@pares) { 
		      	($nombre, $valor) = split(/\=/, $par); 
				if (defined $parame_tmp{$nombre}) {
					$parame_tmp{$nombre}.="\n$valor";
				} else {
					$parame_tmp{$nombre}=$valor;
					$orden_entrada{$total}=$nombre;
					$total++;
				}


			}
			undef $nombre_fichero;
		}
	}
	while(($nombre,$valor)=each(%parame_tmp)){
		if (!defined $nombre_fichero{$nombre}){
			$nombre =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
	      	$nombre =~ tr/\+/ /; 
			$valor =~ s/\%25/\%/g;	
			$valor =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
	      	$valor =~ tr/\+/ /;
	     		$valor =~ s/\+(.*)/$1/g;
	    		$valor =~ s/(.*)[ \t]+\-(.*)/$1$2/g;
	    		$valor =~ tr/\$\'\`\<\>\|/_/;
	   		$valor =~ s/<!--(.|\n)*-->//g; 
			$nombre =~ s/\-+(.*)/$1/g;
   			$nombre =~ s/(.*)[ \t]+\-(.*)/$1$2/g;
   			$nombre =~ tr/\$\'\`\"\<\>\;\!\|/_/;
    			$nombre =~ s/<!--(.|\n)*-->//g; 
		}
		$parame{$nombre}=$valor;

		#if ($tipo_form !~ m#^multipart/form-data#){$total++;}
	}
	return $total;
}

sub envia_mail
{
my ($tipo,$programa,$mensaje,$de_quien,@a_quien)=@_;

if ($tipo eq "smtp"){
	my $estado = &sendmail_win($programa,$mensaje,$de_quien,@a_quien);
	return $estado;
} else {
 	if (open (MAIL, "|$programa")){ 	
		print MAIL "$mensaje";
		close (MAIL);
		return 0;
 	} else {
		return -1;
	}
}
return -2;
}
sub sendmail_win {
my ($smtp_server, $mensaje, $de_quien,@a_quien) = @_;

my ($name, $aliases, $proto, $type, $len, $thisaddr, $thataddr);
my ($this, $that);
local *S; 
#--- Puerto 25 para el envio de correos
my ($port) = 25;
my ($AF_INET)     =  2;
my ($SOCK_STREAM) =  1;
my ($sockaddr) = 'S n a4 x8';


if ($@){ 
	print "Content-type:text/html\n\n";
	print "Error: No encuentro el m&oacute;dulo Perl5: Socket.pm\n Mensaje del sistema: ($!)\n $@ Glubs!\n"; 
	return -255;
}

$mensaje =~ s/^\./\.\./gm; # handle . as first character
$mensaje =~ s/\r\n/\n/g; # handle line ending
$mensaje =~ s/\n/\r\n/g;
$smtp_server =~ s/^\s+//g; # remove spaces around smtp_server
$smtp_server =~ s/\s+$//g;

($name, $aliases, $proto) = getprotobyname ('tcp');
($name, $aliases, $port) = getservbyname ($port,'tcp') unless $port =~ /^\d+$/;
if ($fix_mail eq "Si") {
 	($name, $aliases, $type, $len, $thataddr) = gethostbyname ($smtp_server);
 	if (!socket(S, $AF_INET, $SOCK_STREAM, $proto)){
		# print "Content-type:text/html\n\n";
		# print "Fallo en el socket hacia el servidor de correo: $smtp_server $!\n";
		return -255;
	}
 	if (!bind(S, pack('S n a4 x8', $AF_INET, 0, "\0\0\0\0"))){
		# print "Content-type:text/html\n\n";
	 	# print "Error <I>Bind</I> con el servidor de mail: $smtp_server ($!)\n";
		return -255;
	}
 	if (!connect(S, pack('S n a4 x8', $AF_INET, $port, $thataddr))){
		# print "Content-type:text/html\n\n";
	 	# print "Conexi&oacute;n fallida con sevidor de correo: $smtp_server ($!)\n";
		return -255;
	}
}else{
 	($name, $aliases, $type, $len, $thisaddr) = gethostbyname ("localhost");
 	($name, $aliases, $type, $len, $thisaddr) = gethostbyname ($name);
 	($name, $aliases, $type, $len, $thataddr) = gethostbyname ($smtp_server);

 	$this = pack ($sockaddr, AF_INET, 0, $thisaddr);
 	$that = pack ($sockaddr, AF_INET, $port, $thataddr);

 	if (!socket (S, AF_INET, SOCK_STREAM, $proto)){
		# print "Content-type:text/html\n\n";
		# print "Fallo en el socket hacia el servidor de correo: $smtp_server $!\n";
		return -255;
	}
 	if (!bind (S, $this)){
		# print "Content-type:text/html\n\n";
	 	# print "Error <I>Bind</I> con el servidor de mail: $smtp_server ($!)\n";
		return -255;
	}

 	if (!connect (S, $that)){
		# print "Content-type:text/html\n\n";
	 	# print "Conexi&oacute;n fallida con sevidor de correo: $smtp_server ($!)\n";
		return -255;
	}

 } 

select (S); $| = 1; select (STDOUT);
return -1 unless (&wait_for (*S, '220'));

print S "HELO $smtp_server\r\n"; 
return -2 unless (&wait_for (*S, '250'));

print S "MAIL FROM:<$de_quien>\r\n";
return -3 unless (&wait_for (*S, '250'));

foreach $tmp (@a_quien){
	print S "RCPT TO:<$tmp>\r\n";
	return -4 unless (&wait_for (*S, '250'));
}

print S "DATA \r\n";
return -5 unless (&wait_for (*S, '354'));


print S "$mensaje\r\n";

print S ".\r\n"; 
return -6 unless (&wait_for (*S, '250'));
print S "QUIT\r\n";

shutdown (S, 2);
close S;

return 0;
}

#-----------------------------

# Subrutina de espera
sub wait_for {
local (*S) = $_[0]; 
my ($exp) = $_[1]; 
my ($str) = ""; 
my ($cc) = ""; 
my ($err) = 0;         # Errores leyendo socket 
my $line_end = "\n";
OUTER:
while ($err < 500) {
do { $err++; next OUTER; } 
if (sysread (S, $cc, 1, 0) != 1);
$err = 0; do { $str .= $cc; next OUTER; } 
if ($cc ne $line_end);
	if ($str =~ /^(\d+)\s+(.*)/) {	# toma xxx de la respuesta 'xxx text' 

		if ($1 == $exp) {	# Si xxx es la respuesta esperada
			return 1;
		} else {
			return 0;
		}
	}
$str = "";
}
return 0;

} 

sub error{
	print "Content-type:text/html\n\n";
	print "<html>\n<body bgcolor=\"#FFFFFF\">\n";
	print "<H2>$_[0]</H2><BR>\n";
	print "$_[1]";
	print "</body>\n</html>\n";
}
### b64encode

sub b64encode
{
    local ($_) = @_;
    local ($chunk,$result,$tr_uuencode);
    local $base64_pad = '='; 
	local $base64_alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
                   		   'abcdefghijklmnopqrstuvwxyz'.
                   		   '0123456789+/';
	local $uuencode_alphabet = q|`!"#$%&'()*+,-./0123456789:;<=>?|.
                      '@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_'; # double that '\\'!

	local $tr_base64 = "A".$base64_alphabet;
	($tr_uuencode = " ".$uuencode_alphabet) =~ s/\\/\\\\/;

    while (s/^((.|\n){45})//) {
		  $chunk = substr(pack("u", $&), $[+1, 60);
		  eval qq{
		  	   \$chunk =~ tr|$tr_uuencode|$tr_base64|;
		  };
		  $result .= $chunk . "\n";
    }

    if ($_ ne "") {
		$chunk = substr(pack("u", $_), $[+1,int((length($_)+2)/3)*4 - (45-length($_))%3);
		eval qq{
	    	 \$chunk =~ tr|$tr_uuencode|$tr_base64|;
		};
		$result .= $chunk . ($base64_pad x ((60 - length($chunk)) % 4)) . "\n";
    }

    $result;
}



